<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <title>Hello OpenCV.js</title>
</head>

<body>
    <h2>Hello OpenCV.js</h2>
    <p id="status">OpenCV.js is loading...</p>
    <div>
        <div class="inputoutput">
            <img id="canvasInput" alt="No Image" />
            <div class="caption">
                <span>imageSrc</span>
                <input type="file" id="fileInput" name="file" />
            </div>
        </div>
        <div class="inputoutput">
            <canvas id="canvasOutput"></canvas>
            <div class="caption">canvasOutput</div>
        </div>
    </div>
    <script type="text/javascript">
        let imgElement = document.getElementById('canvasInput');
        let inputElement = document.getElementById('fileInput');
        inputElement.addEventListener('change', (e) =>
        {
            imgElement.src = URL.createObjectURL(e.target.files[0]);
        }, false);
        imgElement.onload = function()
        {
            let src = cv.imread('canvasInput');
            let dst = cv.Mat.zeros(src.rows, src.cols, cv.CV_8UC3);
            let lines = new cv.Mat();
            let color = new cv.Scalar(255, 0, 0);
            cv.cvtColor(src, src, cv.COLOR_RGBA2GRAY, 0);
            cv.Canny(src, src, 50, 200, 3);
            // You can try more different parameters
            cv.HoughLinesP(src, lines, 1, Math.PI / 180, 2, 0, 0);
            // draw lines
            for (let i = 0; i < lines.rows; ++i)
            {
                let startPoint = new cv.Point(lines.data32S[i * 4], lines
                    .data32S[i * 4 + 1]);
                let endPoint = new cv.Point(lines.data32S[i * 4 + 2],
                    lines.data32S[i * 4 + 3]);
                cv.line(dst, startPoint, endPoint, color);
            }
            cv.imshow('canvasOutput', dst);
            src.delete();
            dst.delete();
            lines.delete();

        };
        var Module = {
            // https://emscripten.org/docs/api_reference/module.html#Module.onRuntimeInitialized
            onRuntimeInitialized()
            {
                document.getElementById('status').innerHTML =
                    'OpenCV.js is ready.';
            }
        };
    </script>
    <script async src="opencv.js" type="text/javascript"></script>
</body>

</html>
